#!/usr/bin/env python

from sys import argv
import json

from qlbr.models import Criterion, Item, Search, SearchTag, Project


for filename in argv[1:]:
    data = json.load(open(filename))
    for search in data:
        d_search = Search(name=search['name'])
        d_search.save()
        for tag in search['search_tags']:
            d_tag = SearchTag(search_tag=tag)
            d_tag.save()
            d_search.search_tags.add(d_tag)
        for project in search['projects']:
            d_project = Project(project=project)
            d_project.save()
            d_search.projects.add(d_project)
        for key in search['criteria']:
            value = search['criteria'][key]
            if isinstance(value, list):
                d_criterion = Criterion(key=key, is_list=True)
                d_criterion.save()
                for item in value:
                    d_item = Item(item=item)
                    d_item.save()
                    d_criterion.values.add(d_item)
            else:
                d_criterion = Criterion(key=key, value=value)
            d_criterion.save()
            d_search.criteria.add(d_criterion)
        d_search.save()
